#ifndef COM1939_H
#define COM1939_H

// Constants -----------------------------------------------------------------
// ---------------------------------------------------------------------------
const int SYSTEM_LOOP_TIME = 1000;         // microseconds

// System Class --------------------------------------------------------------
// ---------------------------------------------------------------------------
class COM1939
{
    public:
        COM1939();
        virtual ~COM1939();

        // jCOM Gateway
        bool bjCOM1939Heartbeat;            // Will toggle every second

        // COM Port
        int fileCOMPort;                    // COM port file handle
        char sPort[20];                     // String representation of used port

        // Error Management
        bool bCommunicationError;           // Global error flag
        int nErrNum;

        bool bErrorOpenCOMPort;             // True = Error opening COM port
        bool bErrorCOMPortSettings;         // True = Error applying COM port settings

        // Protocol Functions
        int Initialize(char* sCOMPort);     // For instance "/dev/ttyUSB0"
        int Receive(long* lPGN, int* nPriority, int* nSourceAddress, int* nDestAddress, byte nData[], int* nDataLen, bool *bTimeStamp, byte nTimeStamp[]);
        int Transmit(int nPriority, long lPGN, int nSourceAddress, int nDestAddress, byte nData[], int nDataLen);
        void SetProtocolParameters(byte* nNAME, byte nSA, byte nSABottom, byte nSATop, byte nOpMode, bool bReqRSMessage);
        void Terminate(void);

        // Gateway management functions
        void GetVersion(char* sSWVersion, char* sHWVersion);
        void ResetGateway(int nCANBaudRate);
        void SendMessageMode(byte nMsgMode);
        void AddFilter(long lPGN);
        void DelFilter(long lPGN);
        void AddFilterX(long lPGN, int nSampleRate);
        void RequestStatus(void);
        int GetStatus(int *nSA);

   protected:

   private:

};

#endif // COM1939_H
